# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rosee_msg/GraspingActionsAvailableRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class GraspingActionsAvailableRequest(genpy.Message):
  _md5sum = "e0fc1f83bfa951886e0853a85fdb337f"
  _type = "rosee_msg/GraspingActionsAvailableRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# With this service info about a bunch primitive is shared (name, keys, motor position and so on)
# Specifing the request, only a subset (even one) of primitives can be given
# All the request field are optional (if no request at all, alla actions are given), more than one field
# can be combined (eg I want a action_name=Trig done with finger index (elements_involved = finger)

# NOTE Message fields should be lowercase with underscore separation. e.g. range_min


# action type, that is an enum and with msg we can only define it like this
# remember to add here if we add new type in Action.h and ActionPrimitive.h
# if some caller is asking for only a type, otherwise 0 is the default then all action are sent

uint8 PRIMITIVE = 0
uint8 GENERIC_and_COMPOSED = 1 
uint8 TIMED = 2

uint8 action_type

# subtype for primitive, no meaning if action_type is not primitive
uint8 PRIMITIVE_ALL = 0
uint8 PRIMITIVE_PINCHSTRONG = 1
uint8 PRIMITIVE_PINCHWEAK = 2
uint8 PRIMITIVE_MULTIPLEPINCHSTRONG = 3
uint8 PRIMITIVE_TRIG = 4
uint8 PRIMITIVE_TIPFLEX = 5
uint8 PRIMITIVE_FINGFLEX = 6
uint8 PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 7
uint8 PRIMITIVE_NONE = 8

uint8 primitive_type

# this field can be used to take only an action by name. (action_type field = 0 is then overriden, but error is given if we are
# asking for a specific type (action_type != 0) but the name refer to an action of another type)
string action_name

# this field can be used to take only a primitive done with this element 
# (so useless field if action_name is empty or action is not a primitive)
# a vector that can also contain only a element
string[] elements_involved
"""
  # Pseudo-constants
  PRIMITIVE = 0
  GENERIC_and_COMPOSED = 1
  TIMED = 2
  PRIMITIVE_ALL = 0
  PRIMITIVE_PINCHSTRONG = 1
  PRIMITIVE_PINCHWEAK = 2
  PRIMITIVE_MULTIPLEPINCHSTRONG = 3
  PRIMITIVE_TRIG = 4
  PRIMITIVE_TIPFLEX = 5
  PRIMITIVE_FINGFLEX = 6
  PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 7
  PRIMITIVE_NONE = 8

  __slots__ = ['action_type','primitive_type','action_name','elements_involved']
  _slot_types = ['uint8','uint8','string','string[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       action_type,primitive_type,action_name,elements_involved

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GraspingActionsAvailableRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.action_type is None:
        self.action_type = 0
      if self.primitive_type is None:
        self.primitive_type = 0
      if self.action_name is None:
        self.action_name = ''
      if self.elements_involved is None:
        self.elements_involved = []
    else:
      self.action_type = 0
      self.primitive_type = 0
      self.action_name = ''
      self.elements_involved = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.action_type, _x.primitive_type))
      _x = self.action_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.elements_involved)
      buff.write(_struct_I.pack(length))
      for val1 in self.elements_involved:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 2
      (_x.action_type, _x.primitive_type,) = _get_struct_2B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.elements_involved = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.elements_involved.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.action_type, _x.primitive_type))
      _x = self.action_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.elements_involved)
      buff.write(_struct_I.pack(length))
      for val1 in self.elements_involved:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 2
      (_x.action_type, _x.primitive_type,) = _get_struct_2B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.elements_involved = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.elements_involved.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rosee_msg/GraspingActionsAvailableResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import rosee_msg.msg

class GraspingActionsAvailableResponse(genpy.Message):
  _md5sum = "4b9f975ab22f224c58ebf13145135878"
  _type = "rosee_msg/GraspingActionsAvailableResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """GraspingAction[] grasping_actions




================================================================================
MSG: rosee_msg/GraspingAction
## Info message, used by GraspingActionsAvailable service, which store the infos about a specific action

# action type, that is an enum and with msg we can only define it like this
# remember to add here if we add new type in Action.h and ActionPrimitive.h ..

uint8 PRIMITIVE = 0
uint8 GENERIC = 1
uint8 COMPOSED  = 2
uint8 TIMED = 3
uint8 NONE = 4
uint8 action_type

# subtype for primitive, no meaning if action_type is not 1
uint8 PRIMITIVE_PINCHTIGHT = 0
uint8 PRIMITIVE_PINCHLOOSE = 1
uint8 PRIMITIVE_MULTIPLEPINCHTIGHT = 2
uint8 PRIMITIVE_TRIG = 3
uint8 PRIMITIVE_TIPFLEX = 4
uint8 PRIMITIVE_FINGFLEX = 5
uint8 PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 6
uint8 PRIMITIVE_NONE = 7
uint8 primitive_type

# name of the action
string action_name

# names of the selectable fingers/joints (eg 2 finger for pinch) if any
string[] elements_involved

# The mask which says if the motor is used by the action (count > 0) or not (count = 0). 
# It is unique for each action (differently from action_motor_positions which is a vector) 
JointsInvolvedCount action_motor_count

# actuator position associated with the action. Can be more than one for some action (like pinches and PRIMITIVE_SINGLEJOINTMULTIPLETIPS)
MotorPosition[] action_motor_positions

#used only for timed and composed
string[] inner_actions

## used only for timed.. better to make a new msg?
float64[] before_time_margins
float64[] after_time_margins


================================================================================
MSG: rosee_msg/JointsInvolvedCount
# This is the msg for the type 
#    "typedef std::map <std::string, unsigned int> JointsInvolvedCount"


# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states. 

string[] name
uint8[] count


================================================================================
MSG: rosee_msg/MotorPosition
# I do not want to use standard joint state because also velocity and effort are present, which are not used by an action

# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

string[] name
float64[] position
"""
  __slots__ = ['grasping_actions']
  _slot_types = ['rosee_msg/GraspingAction[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       grasping_actions

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GraspingActionsAvailableResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.grasping_actions is None:
        self.grasping_actions = []
    else:
      self.grasping_actions = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.grasping_actions)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasping_actions:
        _x = val1
        buff.write(_get_struct_2B().pack(_x.action_type, _x.primitive_type))
        _x = val1.action_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.elements_involved)
        buff.write(_struct_I.pack(length))
        for val2 in val1.elements_involved:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val2))
        _v1 = val1.action_motor_count
        length = len(_v1.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v1.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val3))
        _x = _v1.count
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.action_motor_positions)
        buff.write(_struct_I.pack(length))
        for val2 in val1.action_motor_positions:
          length = len(val2.name)
          buff.write(_struct_I.pack(length))
          for val3 in val2.name:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            buff.write(struct.Struct('<I%ss'%length).pack(length, val3))
          length = len(val2.position)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.Struct(pattern).pack(*val2.position))
        length = len(val1.inner_actions)
        buff.write(_struct_I.pack(length))
        for val2 in val1.inner_actions:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val2))
        length = len(val1.before_time_margins)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.Struct(pattern).pack(*val1.before_time_margins))
        length = len(val1.after_time_margins)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.Struct(pattern).pack(*val1.after_time_margins))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.grasping_actions is None:
        self.grasping_actions = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasping_actions = []
      for i in range(0, length):
        val1 = rosee_msg.msg.GraspingAction()
        _x = val1
        start = end
        end += 2
        (_x.action_type, _x.primitive_type,) = _get_struct_2B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.action_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.action_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.elements_involved = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2 = str[start:end]
          val1.elements_involved.append(val2)
        _v2 = val1.action_motor_count
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v2.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val3 = str[start:end]
          _v2.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v2.count = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.action_motor_positions = []
        for i in range(0, length):
          val2 = rosee_msg.msg.MotorPosition()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.name = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3 = str[start:end]
            val2.name.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          s = struct.Struct(pattern)
          end += s.size
          val2.position = s.unpack(str[start:end])
          val1.action_motor_positions.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.inner_actions = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2 = str[start:end]
          val1.inner_actions.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.before_time_margins = s.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.after_time_margins = s.unpack(str[start:end])
        self.grasping_actions.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.grasping_actions)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasping_actions:
        _x = val1
        buff.write(_get_struct_2B().pack(_x.action_type, _x.primitive_type))
        _x = val1.action_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.elements_involved)
        buff.write(_struct_I.pack(length))
        for val2 in val1.elements_involved:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val2))
        _v3 = val1.action_motor_count
        length = len(_v3.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v3.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val3))
        _x = _v3.count
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        length = len(val1.action_motor_positions)
        buff.write(_struct_I.pack(length))
        for val2 in val1.action_motor_positions:
          length = len(val2.name)
          buff.write(_struct_I.pack(length))
          for val3 in val2.name:
            length = len(val3)
            if python3 or type(val3) == unicode:
              val3 = val3.encode('utf-8')
              length = len(val3)
            buff.write(struct.Struct('<I%ss'%length).pack(length, val3))
          length = len(val2.position)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(val2.position.tostring())
        length = len(val1.inner_actions)
        buff.write(_struct_I.pack(length))
        for val2 in val1.inner_actions:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val2))
        length = len(val1.before_time_margins)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.before_time_margins.tostring())
        length = len(val1.after_time_margins)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.after_time_margins.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.grasping_actions is None:
        self.grasping_actions = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasping_actions = []
      for i in range(0, length):
        val1 = rosee_msg.msg.GraspingAction()
        _x = val1
        start = end
        end += 2
        (_x.action_type, _x.primitive_type,) = _get_struct_2B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.action_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.action_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.elements_involved = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2 = str[start:end]
          val1.elements_involved.append(val2)
        _v4 = val1.action_motor_count
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v4.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val3 = str[start:end]
          _v4.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v4.count = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.action_motor_positions = []
        for i in range(0, length):
          val2 = rosee_msg.msg.MotorPosition()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.name = []
          for i in range(0, length):
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3 = str[start:end].decode('utf-8', 'rosmsg')
            else:
              val3 = str[start:end]
            val2.name.append(val3)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          s = struct.Struct(pattern)
          end += s.size
          val2.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          val1.action_motor_positions.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.inner_actions = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2 = str[start:end]
          val1.inner_actions.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.before_time_margins = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.after_time_margins = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.grasping_actions.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
class GraspingActionsAvailable(object):
  _type          = 'rosee_msg/GraspingActionsAvailable'
  _md5sum = 'a45f809adf487772b66098c9cd5d7903'
  _request_class  = GraspingActionsAvailableRequest
  _response_class = GraspingActionsAvailableResponse
