// Auto-generated. Do not edit!

// (in-package rosee_msg.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class GraspingPrimitiveAggregated {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.action_name = null;
      this.primitive_type = null;
      this.selectable_names = null;
      this.max_selectable = null;
    }
    else {
      if (initObj.hasOwnProperty('action_name')) {
        this.action_name = initObj.action_name
      }
      else {
        this.action_name = '';
      }
      if (initObj.hasOwnProperty('primitive_type')) {
        this.primitive_type = initObj.primitive_type
      }
      else {
        this.primitive_type = 0;
      }
      if (initObj.hasOwnProperty('selectable_names')) {
        this.selectable_names = initObj.selectable_names
      }
      else {
        this.selectable_names = [];
      }
      if (initObj.hasOwnProperty('max_selectable')) {
        this.max_selectable = initObj.max_selectable
      }
      else {
        this.max_selectable = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GraspingPrimitiveAggregated
    // Serialize message field [action_name]
    bufferOffset = _serializer.string(obj.action_name, buffer, bufferOffset);
    // Serialize message field [primitive_type]
    bufferOffset = _serializer.uint8(obj.primitive_type, buffer, bufferOffset);
    // Serialize message field [selectable_names]
    bufferOffset = _arraySerializer.string(obj.selectable_names, buffer, bufferOffset, null);
    // Serialize message field [max_selectable]
    bufferOffset = _serializer.uint8(obj.max_selectable, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GraspingPrimitiveAggregated
    let len;
    let data = new GraspingPrimitiveAggregated(null);
    // Deserialize message field [action_name]
    data.action_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [primitive_type]
    data.primitive_type = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [selectable_names]
    data.selectable_names = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [max_selectable]
    data.max_selectable = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.action_name);
    object.selectable_names.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    return length + 10;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rosee_msg/GraspingPrimitiveAggregated';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '9923434b3aad5f3430b0b5e22d639c19';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ## Info about aggregated primitive (for all trig there is only a single message)
    ## used only by GUI for now
    
    # name of the action
    string action_name
    
    uint8 PRIMITIVE_PINCHSTRONG = 0
    uint8 PRIMITIVE_PINCHWEAK = 1
    uint8 PRIMITIVE_MULTIPLEPINCHSTRONG = 2
    uint8 PRIMITIVE_TRIG = 3
    uint8 PRIMITIVE_TIPFLEX = 4
    uint8 PRIMITIVE_FINGFLEX = 5
    uint8 PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 6
    uint8 PRIMITIVE_NONE = 7
    uint8 primitive_type
    
    # names of the selectable fingers/joints ALL aggregated. This means that
    # for example, a trig primitive will have in this field all the fingers that can be used
    # for a trig; also the pinch, and the "pairing" info here is lost (can be retrieved 
    # by the other service SelectablePairInfo
    string[] selectable_names
    
    # number of necessary selectable_names to select before sending message
    # (eg 1 for trig, 2 for pinch, 1 for moreTips)
    uint8 max_selectable
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GraspingPrimitiveAggregated(null);
    if (msg.action_name !== undefined) {
      resolved.action_name = msg.action_name;
    }
    else {
      resolved.action_name = ''
    }

    if (msg.primitive_type !== undefined) {
      resolved.primitive_type = msg.primitive_type;
    }
    else {
      resolved.primitive_type = 0
    }

    if (msg.selectable_names !== undefined) {
      resolved.selectable_names = msg.selectable_names;
    }
    else {
      resolved.selectable_names = []
    }

    if (msg.max_selectable !== undefined) {
      resolved.max_selectable = msg.max_selectable;
    }
    else {
      resolved.max_selectable = 0
    }

    return resolved;
    }
};

// Constants for message
GraspingPrimitiveAggregated.Constants = {
  PRIMITIVE_PINCHSTRONG: 0,
  PRIMITIVE_PINCHWEAK: 1,
  PRIMITIVE_MULTIPLEPINCHSTRONG: 2,
  PRIMITIVE_TRIG: 3,
  PRIMITIVE_TIPFLEX: 4,
  PRIMITIVE_FINGFLEX: 5,
  PRIMITIVE_SINGLEJOINTMULTIPLETIPS: 6,
  PRIMITIVE_NONE: 7,
}

module.exports = GraspingPrimitiveAggregated;
