// Auto-generated. Do not edit!

// (in-package rosee_msg.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let NewGenericGraspingAction = require('../msg/NewGenericGraspingAction.js');

//-----------------------------------------------------------


//-----------------------------------------------------------

class NewGenericGraspingActionSrvRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.newAction = null;
      this.emitYaml = null;
    }
    else {
      if (initObj.hasOwnProperty('newAction')) {
        this.newAction = initObj.newAction
      }
      else {
        this.newAction = new NewGenericGraspingAction();
      }
      if (initObj.hasOwnProperty('emitYaml')) {
        this.emitYaml = initObj.emitYaml
      }
      else {
        this.emitYaml = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type NewGenericGraspingActionSrvRequest
    // Serialize message field [newAction]
    bufferOffset = NewGenericGraspingAction.serialize(obj.newAction, buffer, bufferOffset);
    // Serialize message field [emitYaml]
    bufferOffset = _serializer.bool(obj.emitYaml, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type NewGenericGraspingActionSrvRequest
    let len;
    let data = new NewGenericGraspingActionSrvRequest(null);
    // Deserialize message field [newAction]
    data.newAction = NewGenericGraspingAction.deserialize(buffer, bufferOffset);
    // Deserialize message field [emitYaml]
    data.emitYaml = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += NewGenericGraspingAction.getMessageSize(object.newAction);
    return length + 1;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rosee_msg/NewGenericGraspingActionSrvRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '5c8aaa1397a9c435f368f25efcaf70fe';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ## Service associated with GenericGraspingAction message
    
    NewGenericGraspingAction newAction
    
    # user can also request to store the action in a yaml file, togheter with the others
    bool emitYaml
    
    
    ================================================================================
    MSG: rosee_msg/NewGenericGraspingAction
    # Message which include all the infos necessary to insert a new action in the system 
    # (https://github.com/ADVRHumanoids/ROSEndEffector/issues/71)
    
    # name of the action
    string action_name
    
    # Motor Position
    MotorPosition action_motor_position
    
    # OPTIONAL The mask which says if the motor is used by the action (count > 0) or not (count = 0).
    # take care that if it is not included, the not used joint will be considered the ones with 0 position
    JointsInvolvedCount action_motor_count
                                      
    # OPTIONAL field to indicate which hand element will be moved by the action
    string[] elements_involved
    
    ================================================================================
    MSG: rosee_msg/MotorPosition
    # I do not want to use standard joint state because also velocity and effort are present, which are not used by an action
    
    # All arrays in this message should have the same size, or be empty.
    # This is the only way to uniquely associate the joint name with the correct
    # states.
    
    string[] name
    float64[] position
    
    ================================================================================
    MSG: rosee_msg/JointsInvolvedCount
    # This is the msg for the type 
    #    "typedef std::map <std::string, unsigned int> JointsInvolvedCount"
    
    
    # All arrays in this message should have the same size, or be empty.
    # This is the only way to uniquely associate the joint name with the correct
    # states. 
    
    string[] name
    uint8[] count
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new NewGenericGraspingActionSrvRequest(null);
    if (msg.newAction !== undefined) {
      resolved.newAction = NewGenericGraspingAction.Resolve(msg.newAction)
    }
    else {
      resolved.newAction = new NewGenericGraspingAction()
    }

    if (msg.emitYaml !== undefined) {
      resolved.emitYaml = msg.emitYaml;
    }
    else {
      resolved.emitYaml = false
    }

    return resolved;
    }
};

class NewGenericGraspingActionSrvResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.accepted = null;
      this.emitted = null;
      this.error_msg = null;
    }
    else {
      if (initObj.hasOwnProperty('accepted')) {
        this.accepted = initObj.accepted
      }
      else {
        this.accepted = false;
      }
      if (initObj.hasOwnProperty('emitted')) {
        this.emitted = initObj.emitted
      }
      else {
        this.emitted = false;
      }
      if (initObj.hasOwnProperty('error_msg')) {
        this.error_msg = initObj.error_msg
      }
      else {
        this.error_msg = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type NewGenericGraspingActionSrvResponse
    // Serialize message field [accepted]
    bufferOffset = _serializer.bool(obj.accepted, buffer, bufferOffset);
    // Serialize message field [emitted]
    bufferOffset = _serializer.bool(obj.emitted, buffer, bufferOffset);
    // Serialize message field [error_msg]
    bufferOffset = _serializer.string(obj.error_msg, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type NewGenericGraspingActionSrvResponse
    let len;
    let data = new NewGenericGraspingActionSrvResponse(null);
    // Deserialize message field [accepted]
    data.accepted = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [emitted]
    data.emitted = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [error_msg]
    data.error_msg = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.error_msg);
    return length + 6;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rosee_msg/NewGenericGraspingActionSrvResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '07a4c65769c1bf305a41a83f2f9eb211';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    # the service will give true if action is good and it is inserted in the structure
    bool accepted
    
    # true false depending if emission on yaml file is successful
    bool emitted
    
    # string containing useful info about a possible not acceptance
    string error_msg
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new NewGenericGraspingActionSrvResponse(null);
    if (msg.accepted !== undefined) {
      resolved.accepted = msg.accepted;
    }
    else {
      resolved.accepted = false
    }

    if (msg.emitted !== undefined) {
      resolved.emitted = msg.emitted;
    }
    else {
      resolved.emitted = false
    }

    if (msg.error_msg !== undefined) {
      resolved.error_msg = msg.error_msg;
    }
    else {
      resolved.error_msg = ''
    }

    return resolved;
    }
};

module.exports = {
  Request: NewGenericGraspingActionSrvRequest,
  Response: NewGenericGraspingActionSrvResponse,
  md5sum() { return '791b81fd4353d7406ebecb6484da4d56'; },
  datatype() { return 'rosee_msg/NewGenericGraspingActionSrv'; }
};
